# Linux Networking Fundamentals

## Prerequisites

- High-level knowledge of commonly used jargon in TCP/IP stack like  DNS, TCP, UDP and HTTP
- [Linux Commandline Basics](https://linkedin.github.io/school-of-sre/linux_basics/command_line_basics/)

## What to expect from this course

Throughout the course, we cover how an SRE can optimize the system to improve their web stack performance and troubleshoot if there is an issue in any of the layers of the networking stack. This course tries to dig through each layer of traditional TCP/IP stack and expects an SRE to have a picture beyond the bird’s eye view of the functioning of the Internet.

## What is not covered under this course

This course spends time on the fundamentals. We are not covering concepts like [HTTP/2.0](https://en.wikipedia.org/wiki/HTTP/2), [QUIC](https://en.wikipedia.org/wiki/QUIC), [TCP congestion control protocols](https://en.wikipedia.org/wiki/TCP_congestion_control), [Anycast](https://en.wikipedia.org/wiki/Anycast), [BGP](https://en.wikipedia.org/wiki/Border_Gateway_Protocol), [CDN](https://en.wikipedia.org/wiki/Content_delivery_network), [Tunnels](https://en.wikipedia.org/wiki/Virtual_private_network) and [Multicast](https://en.wikipedia.org/wiki/Multicast). We expect that this course will provide the relevant basics to understand such concepts

## Birds eye view of the course

The course covers the question “What happens when you open linkedin.com in your browser?” The course follows the flow of TCP/IP stack.More specifically, the course covers topics of Application layer protocols DNS and HTTP, transport layer protocols UDP and TCP, networking layer protocol IP and Data Link Layer protocol 

##  Course Contents
1. [DNS](https://linkedin.github.io/school-of-sre/linux_networking/dns/)
2. [UDP](https://linkedin.github.io/school-of-sre/linux_networking/udp/)
3. [HTTP](https://linkedin.github.io/school-of-sre/linux_networking/http/)
4. [TCP](https://linkedin.github.io/school-of-sre/linux_networking/tcp/)
5. [IP Routing](https://linkedin.github.io/school-of-sre/linux_networking/ipr/)
